﻿# -*- coding:Utf-8 -*-
# ./addons/eventscripts/forcechangemap/forcechangemap.py

'''
	=================================[ Code par Messiah ]=================================
	* Nom du script : ForceChangeMap                                                     *
	* Version       : v0.10                                                              *
	* Auteur        : Messiah93                                                          *
	* Page internet : http://addons.eventscripts.com/addons/view/ForceChangeMap          *
	* Notes         : Merci de ne pas modifier la variable publique.                     *
	* Licence       : (Aucune pour ce script)                                            *
	=================================[ Code par Messiah ]=================================
'''


import es
import gamethread

import psyco
psyco.full()


info = es.AddonInfo()
info.name = "ForceChangeMap"
info.version = "v0.10"
info.author = "Messiah93" 
info.url = "http://www.messiah93.net/"


def load ():
	es.ServerVar ("Messiah93_ForceChangemap", info["version"], "Script permettant de forcer l'arret d'une map dès que le temps arrive à ZERO.").makepublic()
	es.msg ("#multi", "#default[#greenForceChangeMap#default] Script #lightgreenChargé avec succès#default !")
	es.log ("[ForceChangeMap] : Script charge avec succes !")
	load_changemap()


def unload ():
	es.msg ("#multi", "#default[#greenForceChangeMap#default] Script #lightgreenDéchargé avec succès#default !")
	es.log ("[ForceChangeMap] : Script decharge avec succes !")


def es_map_start (event_var):
	gamethread.delayed(5, tracking)


def load_changemap ():
	gamethread.delayed (2, es.msg, ("#multi", "#default[#greenForceChangeMap#default] Changement de map dans #lightgreen5 secondes#defaut afin d'initialiser le script."))
	gamethread.delayed (2, es.log, ("Changement de map dans 5 secondes afin d'initialiser le script."))
	gamethread.delayed (7, es.server.queuecmd, ("changelevel %s" % es.server_var["eventscripts_currentmap"]))


def tracking ():
	Maptime = es.server_var["mp_timelimit"]
	Maptime *= 60
	Maptime -= 6
	es.log ("[ForceChangeMap] : Le temps en secondes de la map est estimee a : %s secondes !" % Maptime)
	check_changemap(Maptime)
	

def check_changemap (Time):
	if Time <= 0:
		changemap()
		return
	else:
		if Time == 1800:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste approximativement #lightgreen30#default minutes de jeu !")
		elif Time == 1200:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste approximativement #lightgreen20#default minutes de jeu !")
		elif Time == 600:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste approximativement #lightgreen10#default minutes de jeu !")
		elif Time == 300:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste approximativement #lightgreen5#default minutes de jeu !")
		elif Time == 60:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste approximativement #lightgreen1#default minute de jeu !")
		elif Time == 5:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste #lightgreen5#default secondes avant la fin de la map !")
		elif Time == 4:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste #lightgreen4#default secondes avant la fin de la map !")
		elif Time == 3:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste #lightgreen3#default secondes avant la fin de la map !")
		elif Time == 2:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste #lightgreen2#default secondes avant la fin de la map !")
		elif Time == 1:
			es.msg ("#multi", "#default[#greenForceChangeMap#default] Il reste #lightgreen1#default secondes avant la fin de la map !")
	Time -= 1
	gamethread.delayed (1, check_changemap, (Time))


def changemap ():
	Found_player = es.getuserid()
	if Found_player != 0:
		es.server.queuecmd ("es_xgive %s game_end" % Found_player)
		es.server.queuecmd ("es_xfire %s game_end EndGame" % Found_player)
		es.msg ("#multi", "#default[#greenForceChangeMap#default] Changement de map imminent !")
		es.log ("[ForceChangeMap] : Changement de map !")
		es.centermsg ("Changement de map imminent !")
		for userids in es.getUseridList():
			es.toptext (userids, 5, "#red", "Changement de map imminent !")
	else:
		es.log ("[ForceChangeMap] : Aucun joueur trouve pour changer la map - Ajout d'un bot pour suivre l'userid !")
		es.server.queuecmd("es_createbot \"ForceChangeMap - UserID BOT\"")
		gamethread.delayed (1, changemap)
	